package com.bjtdba.order.dao;

import com.bjtdba.entity.order.StoreCart;
import com.bjtdba.order.vo.StoreCartVo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 购物车表(StoreCart)表数据库访问层
 *
 * @author makejava
 * @since 2022-09-29 14:39:50
 */
@Repository
@Mapper
public interface StoreCartDao {

    /**
     * 通过ID查询单条数据
     *
     * @param cartId 主键
     * @return 实例对象
     */
    StoreCart queryById(Long cartId);

    /**
     * 查询指定行数据
     *
     * @param storeCart 查询条件
     * @param pageable         分页对象
     * @return 对象列表
     */
    List<StoreCart> queryAllByLimit(StoreCart storeCart);

    /**
     * 统计总行数
     *
     * @param storeCart 查询条件
     * @return 总行数
     */
    long count(StoreCart storeCart);

    /**
     * 新增数据
     *
     * @param storeCart 实例对象
     * @return 影响行数
     */
    int insert(StoreCart storeCart);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<StoreCart> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<StoreCart> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<StoreCart> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<StoreCart> entities);

    /**
     * 修改数据
     *
     * @param storeCart 实例对象
     * @return 影响行数
     */
    int update(StoreCart storeCart);

    /**
     * 通过主键删除数据
     *
     * @param cartId 主键
     * @return 影响行数
     */
    int deleteById(Long cartId);

    int  batchDelete(String [] cartIds,Long uid);

    /**
     * 通过用户查询购物车对应的所有商户
     * @param uid
     * @return
     */
    public Integer[] getMerids(Long uid);

    /**
     * 通过用户查询用户所有对应的商品信息
     * @param uid
     * @return
     */
    public List<StoreCartVo>  queryByuid(Long uid);

    /**
     * 通过用户id，购物车id查询购物车信息
     * @param uid
     * @param cartId
     * @return
     */
    public StoreCartVo  queryByUidCartId(Long uid,Long cartId);

    /**
     * 返回商户列表数组
     * @param num
     * @return
     */
    public  Integer[] getMeridsMerchantType(Integer num);

    /**
     * 通过购物车多id查询
     * @param cartIds
     * @return
     */
    public List<StoreCart> getStoreCartList(String[] cartIds);

}

